function [ boolean, nemo_data ] = optimare2nemostruct( p_optimare_data )
%OPTIMARE2NEMOSTRUCT Converts the optimare data structure to nemo format.
%   Converts the given optimare data structure to the nemo data format that
%   is used by this library.
% 
%   Parameters:
%   p_optimare_float:   Data structure created by the decoding process
%                       written by optimare. In case of the source
%                       nemo2profile, this should be
%                       handles.all_floats.(float_name)
%
%   Returns:
%   boolean:    False if the conversion failed.
%   nemo_data:  The converted float data.
%

%% Initialize return variables
boolean = false;
nemo_data = {};

%% Parameter check (not implemented yet)

floatnames = fieldnames(p_optimare_data);
converted_floatcount = 0;

for o_float = 1:length(floatnames)
    
    % get current float data
    current_float = p_optimare_data.(floatnames{o_float});
    
    converted_float = nemo.convert.float(current_float);
        
    if ~iscell(converted_float)
        warning(['Error converting ' floatnames{o_float} '!']);
    else
        % store it to nemo data
        converted_floatcount = converted_floatcount + 1;
        nemo_data{converted_floatcount} = converted_float;
        clear converted_float
    end

end

boolean = true;


end

