function [ processed_inline ] = float_transmission_info( p_config, p_imei )
%FLOAT_TRANSMITTION_INFO Reads the transmittion information stored in the mail body. 
%   Loads all mail bodies of the given IMEI and stores the processed text
%   in a cell.
%
%   Parameters:
%   p_config:           The nemo configuration.
%   p_imei:             The IMEI to load the information.
%
%   Returns:
%   processed_inline:   A cell containing the processed information.

%% Initialize return variables
processed_inline = false;

%% TODO: Parameter check


%% Load inline file(s)
txt = ['txt' p_config.GENERAL.folder_separator];
if (~ischar(p_imei))
    imei = int2str(p_imei);
else
    imei = p_imei;
end

% create full filepath
filepath = p_config.MAIL.storage_directory;

if (p_config.MAIL.sort_by_imei)
    filepath = [filepath imei p_config.GENERAL.folder_separator];
end
if (p_config.MAIL.separate_sbd_and_txt)
    filepath = [filepath txt];
end
filenames = struct2table(dir([filepath '*.txt']));
if (isempty(filenames.name))
    return;
end
absolute_filenames = cellfun(@(name) [filepath p_config.GENERAL.folder_separator name], filenames.name, 'UniformOutput', false);
processed_inline = cellfun(@read_file, absolute_filenames);

    function inline = read_file(filename)
        inline = nemo.mail.process_inline(fileread(filename));
    end

end

