function [device,data,status]=devicedata(devicedata)

    % Decode types
    dd = dec2bin(devicedata,8);
    data = bin2dec(dd(5:8));
    device = bin2dec(dd(1:4));
    status = 1;
    
    % Set device and data type
    switch (device)
        case 1
            % NEMO float
            device = 'NEMO Standard      ';
            switch (data)
                case 0
                    % Test/Startup data
                    data = 'Startup Test Message';
                case 1
                    % Profile data
                    data = 'Profile Message';
                case 2
                    % Report data
                    data = 'MTM Report Message';
                case 3
                    % Recovery data
                    data = 'Recovery Message';
                case 4
                    % File data
                    data = 'File transmission Message';
                case 5
                    % Reserved profile data
                    data = 'Reserved profile Message';
                case 6
                    % Filtered continous profile data 
                    data = 'Filtered CTD data Message';

                otherwise
                    % Unknown data
                    data = 'Unknown Message';
                    %disp(['Unknown data type ('+num2str(dd)+')']);
                    status = 0;
            end
            
        case 2
            % CTD Profiler
            device = 'CTD Profiler/Logger';
            switch (data)
                case 1
                    % Profile data
                    data = 'Profile Message';
               
                otherwise
                    % Unknown data
                    data = 'Unknown Message';
                    %disp(['Unknown data type ('+num2str(dd)+')']);
                    status = 0;
            end
            
        otherwise
            % Unknown device type
            device = 'Unknown';
            status = 0;
    end
    
end